<link rel="import" href="../bower_components/polymer/polymer.html">
<dom-module id="booking-element">
    <template>
        <style>
          :host {
            display: flex;
            --increment-color: black;
            --increment-bg-color: white;
            --decrement-color: black;
            --decrement-bg-color: white;
            --border-color: red;
            --font-size: inherit;
            --border-color-booking: LightGrey;
            font-family: sans-serif;
          }
    
          #input {
            padding: .4em;
            text-align: center;
            border: 0;
            font-size: var(--font-size);
          }
          .property{ 
            border: 1px solid;
            padding: 10px;
            border-color: var(--border-color);
            margin: 10px;
          }
          .buttons {
            display: flex;
            flex-direction: initial;
            font-size: var(--font-size);
          }
    
          .buttons button {
            font-weight: bold;
            border: 0;
            background-color: transparent;
            padding: .4em .9em;
            font-size: inherit;
          }
          .buttons button:active {
            box-shadow: inset 1px -1px 5px 3px rgba(0, 0, 0, 0.3);
          }
          .buttons #increment {
            border-bottom: 0;
            border: 1px solid;
            border-color: var(--border-color);
            color: var(--increment-color);
            background-color: var(--increment-bg-color);
            margin: 10px;
          }
          .buttons #decrement {
            border: 1px solid;
            border-color: var(--border-color);
            color: var(--decrement-color);
            background-color: var(--decrement-bg-color);
            margin: 10px;
          }
          #booking{
            box-sizing: content-box;
            border: 1px solid;
            padding: 10px;
            border-color: var(--border-color-booking);
          }
        </style>
        <aside>
          <h3>Invitados</h3>
          <section id="booking">
            <div class="buttons">
              <button id="decrement" on-tap="decrement" on-click="decrement">-</button>
              <section class="property">
                <input type="number" value="{{count::input}}" id="input" min="[[min]]" max="[[max]]">
                <label>[[plural(count,singularText, pluralText)]]</label>
              </section>
              <button id="increment" on-tap="increment" on-click="increment">+</button>
            </div>
          </section>
        </aside>
      </template>
      <script>
          class BookingElement extends Polymer.Element {
            static get is() { return 'booking-element'; }
            static get properties() {
              return {
                count: {
                  type: Number,
                  value: 0
                },
                min: {
                  type: Number,
                  value: Number.MIN_SAFE_INTEGER
                },
                max: {
                  type: Number,
                  value: Number.MAX_SAFE_INTEGER
                },
                singularText: {
                  type: String,
                  value: "Plaza"
                },
                pluralText: {
                  type: String,
                  value: "Plazas"
                },
              };
            }
            plural(count, singularText, pluralText) {
                  if (count>=1){
                    return pluralText;
                  } else {
                    return singularText;
                  }
            }
            increment() {
              this.count = parseInt(this.count, 10) || 0;
              this.count = Math.min(this.count + 1, this.max);
              this.notify();
            }
            decrement() {
              this.count = parseInt(this.count, 10) || 0;
              this.count = Math.max(this.count - 1, this.min);
              this.notify();
            }
            notify() {
              this.dispatchEvent(new CustomEvent('change', {
                detail: {
                  count: this.count
                }
              }));
            }
          }
          window.customElements.define(BookingElement.is, BookingElement);
        </script>
</dom-module>

